--- a/src/gui/embedded/qkbd_defaultmap_qws_p.h.orig	2013-05-29 13:55:05.371424281 -0400
+++ b/src/gui/embedded/qkbd_defaultmap_qws_p.h	2013-05-29 14:14:50.871398396 -0400
@@ -100,8 +100,8 @@
     {  14, 0xffff, 0x01000003, 0x00, 0x00, 0x0000 },
     {  14, 0xffff, 0x01000000, 0x0c, 0x08, 0x0300 },
     {  15, 0xffff, 0x01000001, 0x00, 0x00, 0x0000 },
-    {  16, 0x0071, 0x00000051, 0x00, 0x00, 0x0000 },
-    {  16, 0x0051, 0x00000051, 0x01, 0x00, 0x0000 },
+    {  16, 0x0071, 0x00000051, 0x00, 0x02, 0x0000 },
+    {  16, 0x0051, 0x00000051, 0x01, 0x02, 0x0000 },
     {  16, 0x0071, 0x00000051, 0x02, 0x00, 0x0000 },
     {  16, 0x0051, 0x00000051, 0x03, 0x00, 0x0000 },
     {  16, 0x0071, 0x04000051, 0x04, 0x00, 0x0000 },
@@ -116,8 +116,8 @@
     {  16, 0x0071, 0x0c000051, 0x0d, 0x00, 0x0000 },
     {  16, 0x0071, 0x0c000051, 0x0e, 0x00, 0x0000 },
     {  16, 0x0071, 0x0c000051, 0x0f, 0x00, 0x0000 },
-    {  17, 0x0077, 0x00000057, 0x00, 0x00, 0x0000 },
-    {  17, 0x0057, 0x00000057, 0x01, 0x00, 0x0000 },
+    {  17, 0x0077, 0x00000057, 0x00, 0x02, 0x0000 },
+    {  17, 0x0057, 0x00000057, 0x01, 0x02, 0x0000 },
     {  17, 0x0077, 0x00000057, 0x02, 0x00, 0x0000 },
     {  17, 0x0057, 0x00000057, 0x03, 0x00, 0x0000 },
     {  17, 0x0077, 0x04000057, 0x04, 0x00, 0x0000 },
@@ -132,8 +132,8 @@
     {  17, 0x0077, 0x0c000057, 0x0d, 0x00, 0x0000 },
     {  17, 0x0077, 0x0c000057, 0x0e, 0x00, 0x0000 },
     {  17, 0x0077, 0x0c000057, 0x0f, 0x00, 0x0000 },
-    {  18, 0x0065, 0x00000045, 0x00, 0x00, 0x0000 },
-    {  18, 0x0045, 0x00000045, 0x01, 0x00, 0x0000 },
+    {  18, 0x0065, 0x00000045, 0x00, 0x02, 0x0000 },
+    {  18, 0x0045, 0x00000045, 0x01, 0x02, 0x0000 },
     {  18, 0x0065, 0x00000045, 0x02, 0x00, 0x0000 },
     {  18, 0x0045, 0x00000045, 0x03, 0x00, 0x0000 },
     {  18, 0x0065, 0x04000045, 0x04, 0x00, 0x0000 },
@@ -148,8 +148,8 @@
     {  18, 0x0065, 0x0c000045, 0x0d, 0x00, 0x0000 },
     {  18, 0x0065, 0x0c000045, 0x0e, 0x00, 0x0000 },
     {  18, 0x0065, 0x0c000045, 0x0f, 0x00, 0x0000 },
-    {  19, 0x0072, 0x00000052, 0x00, 0x00, 0x0000 },
-    {  19, 0x0052, 0x00000052, 0x01, 0x00, 0x0000 },
+    {  19, 0x0072, 0x00000052, 0x00, 0x02, 0x0000 },
+    {  19, 0x0052, 0x00000052, 0x01, 0x02, 0x0000 },
     {  19, 0x0072, 0x00000052, 0x02, 0x00, 0x0000 },
     {  19, 0x0052, 0x00000052, 0x03, 0x00, 0x0000 },
     {  19, 0x0072, 0x04000052, 0x04, 0x00, 0x0000 },
@@ -164,8 +164,8 @@
     {  19, 0x0072, 0x0c000052, 0x0d, 0x00, 0x0000 },
     {  19, 0x0072, 0x0c000052, 0x0e, 0x00, 0x0000 },
     {  19, 0x0072, 0x0c000052, 0x0f, 0x00, 0x0000 },
-    {  20, 0x0074, 0x00000054, 0x00, 0x00, 0x0000 },
-    {  20, 0x0054, 0x00000054, 0x01, 0x00, 0x0000 },
+    {  20, 0x0074, 0x00000054, 0x00, 0x02, 0x0000 },
+    {  20, 0x0054, 0x00000054, 0x01, 0x02, 0x0000 },
     {  20, 0x0074, 0x00000054, 0x02, 0x00, 0x0000 },
     {  20, 0x0054, 0x00000054, 0x03, 0x00, 0x0000 },
     {  20, 0x0074, 0x04000054, 0x04, 0x00, 0x0000 },
@@ -180,8 +180,8 @@
     {  20, 0x0074, 0x0c000054, 0x0d, 0x00, 0x0000 },
     {  20, 0x0074, 0x0c000054, 0x0e, 0x00, 0x0000 },
     {  20, 0x0074, 0x0c000054, 0x0f, 0x00, 0x0000 },
-    {  21, 0x0079, 0x00000059, 0x00, 0x00, 0x0000 },
-    {  21, 0x0059, 0x00000059, 0x01, 0x00, 0x0000 },
+    {  21, 0x0079, 0x00000059, 0x00, 0x02, 0x0000 },
+    {  21, 0x0059, 0x00000059, 0x01, 0x02, 0x0000 },
     {  21, 0x0079, 0x00000059, 0x02, 0x00, 0x0000 },
     {  21, 0x0059, 0x00000059, 0x03, 0x00, 0x0000 },
     {  21, 0x0079, 0x04000059, 0x04, 0x00, 0x0000 },
@@ -196,8 +196,8 @@
     {  21, 0x0079, 0x0c000059, 0x0d, 0x00, 0x0000 },
     {  21, 0x0079, 0x0c000059, 0x0e, 0x00, 0x0000 },
     {  21, 0x0079, 0x0c000059, 0x0f, 0x00, 0x0000 },
-    {  22, 0x0075, 0x00000055, 0x00, 0x00, 0x0000 },
-    {  22, 0x0055, 0x00000055, 0x01, 0x00, 0x0000 },
+    {  22, 0x0075, 0x00000055, 0x00, 0x02, 0x0000 },
+    {  22, 0x0055, 0x00000055, 0x01, 0x02, 0x0000 },
     {  22, 0x0075, 0x00000055, 0x02, 0x00, 0x0000 },
     {  22, 0x0055, 0x00000055, 0x03, 0x00, 0x0000 },
     {  22, 0x0075, 0x04000055, 0x04, 0x00, 0x0000 },
@@ -212,8 +212,8 @@
     {  22, 0x0075, 0x0c000055, 0x0d, 0x00, 0x0000 },
     {  22, 0x0075, 0x0c000055, 0x0e, 0x00, 0x0000 },
     {  22, 0x0075, 0x0c000055, 0x0f, 0x00, 0x0000 },
-    {  23, 0x0069, 0x00000049, 0x00, 0x00, 0x0000 },
-    {  23, 0x0049, 0x00000049, 0x01, 0x00, 0x0000 },
+    {  23, 0x0069, 0x00000049, 0x00, 0x02, 0x0000 },
+    {  23, 0x0049, 0x00000049, 0x01, 0x02, 0x0000 },
     {  23, 0x0069, 0x00000049, 0x02, 0x00, 0x0000 },
     {  23, 0x0049, 0x00000049, 0x03, 0x00, 0x0000 },
     {  23, 0x0069, 0x04000049, 0x04, 0x00, 0x0000 },
@@ -228,8 +228,8 @@
     {  23, 0x0069, 0x0c000049, 0x0d, 0x00, 0x0000 },
     {  23, 0x0069, 0x0c000049, 0x0e, 0x00, 0x0000 },
     {  23, 0x0069, 0x0c000049, 0x0f, 0x00, 0x0000 },
-    {  24, 0x006f, 0x0000004f, 0x00, 0x00, 0x0000 },
-    {  24, 0x004f, 0x0000004f, 0x01, 0x00, 0x0000 },
+    {  24, 0x006f, 0x0000004f, 0x00, 0x02, 0x0000 },
+    {  24, 0x004f, 0x0000004f, 0x01, 0x02, 0x0000 },
     {  24, 0x006f, 0x0000004f, 0x02, 0x00, 0x0000 },
     {  24, 0x004f, 0x0000004f, 0x03, 0x00, 0x0000 },
     {  24, 0x006f, 0x0400004f, 0x04, 0x00, 0x0000 },
@@ -244,8 +244,8 @@
     {  24, 0x006f, 0x0c00004f, 0x0d, 0x00, 0x0000 },
     {  24, 0x006f, 0x0c00004f, 0x0e, 0x00, 0x0000 },
     {  24, 0x006f, 0x0c00004f, 0x0f, 0x00, 0x0000 },
-    {  25, 0x0070, 0x00000050, 0x00, 0x00, 0x0000 },
-    {  25, 0x0050, 0x00000050, 0x01, 0x00, 0x0000 },
+    {  25, 0x0070, 0x00000050, 0x00, 0x02, 0x0000 },
+    {  25, 0x0050, 0x00000050, 0x01, 0x02, 0x0000 },
     {  25, 0x0070, 0x00000050, 0x02, 0x00, 0x0000 },
     {  25, 0x0050, 0x00000050, 0x03, 0x00, 0x0000 },
     {  25, 0x0070, 0x04000050, 0x04, 0x00, 0x0000 },
@@ -270,8 +270,8 @@
     {  28, 0xffff, 0x01000004, 0x00, 0x00, 0x0000 },
     {  28, 0x006d, 0x0c00004d, 0x08, 0x00, 0x0000 },
     {  29, 0xffff, 0x01000021, 0x00, 0x04, 0x0004 },
-    {  30, 0x0061, 0x00000041, 0x00, 0x00, 0x0000 },
-    {  30, 0x0041, 0x00000041, 0x01, 0x00, 0x0000 },
+    {  30, 0x0061, 0x00000041, 0x00, 0x02, 0x0000 },
+    {  30, 0x0041, 0x00000041, 0x01, 0x02, 0x0000 },
     {  30, 0x0061, 0x00000041, 0x02, 0x00, 0x0000 },
     {  30, 0x0041, 0x00000041, 0x03, 0x00, 0x0000 },
     {  30, 0x0061, 0x04000041, 0x04, 0x00, 0x0000 },
@@ -286,8 +286,8 @@
     {  30, 0x0061, 0x0c000041, 0x0d, 0x00, 0x0000 },
     {  30, 0x0061, 0x0c000041, 0x0e, 0x00, 0x0000 },
     {  30, 0x0061, 0x0c000041, 0x0f, 0x00, 0x0000 },
-    {  31, 0x0073, 0x00000053, 0x00, 0x00, 0x0000 },
-    {  31, 0x0053, 0x00000053, 0x01, 0x00, 0x0000 },
+    {  31, 0x0073, 0x00000053, 0x00, 0x02, 0x0000 },
+    {  31, 0x0053, 0x00000053, 0x01, 0x02, 0x0000 },
     {  31, 0x0073, 0x00000053, 0x02, 0x00, 0x0000 },
     {  31, 0x0053, 0x00000053, 0x03, 0x00, 0x0000 },
     {  31, 0x0073, 0x04000053, 0x04, 0x00, 0x0000 },
@@ -302,8 +302,8 @@
     {  31, 0x0073, 0x0c000053, 0x0d, 0x00, 0x0000 },
     {  31, 0x0073, 0x0c000053, 0x0e, 0x00, 0x0000 },
     {  31, 0x0073, 0x0c000053, 0x0f, 0x00, 0x0000 },
-    {  32, 0x0064, 0x00000044, 0x00, 0x00, 0x0000 },
-    {  32, 0x0044, 0x00000044, 0x01, 0x00, 0x0000 },
+    {  32, 0x0064, 0x00000044, 0x00, 0x02, 0x0000 },
+    {  32, 0x0044, 0x00000044, 0x01, 0x02, 0x0000 },
     {  32, 0x0064, 0x00000044, 0x02, 0x00, 0x0000 },
     {  32, 0x0044, 0x00000044, 0x03, 0x00, 0x0000 },
     {  32, 0x0064, 0x04000044, 0x04, 0x00, 0x0000 },
@@ -318,8 +318,8 @@
     {  32, 0x0064, 0x0c000044, 0x0d, 0x00, 0x0000 },
     {  32, 0x0064, 0x0c000044, 0x0e, 0x00, 0x0000 },
     {  32, 0x0064, 0x0c000044, 0x0f, 0x00, 0x0000 },
-    {  33, 0x0066, 0x00000046, 0x00, 0x00, 0x0000 },
-    {  33, 0x0046, 0x00000046, 0x01, 0x00, 0x0000 },
+    {  33, 0x0066, 0x00000046, 0x00, 0x02, 0x0000 },
+    {  33, 0x0046, 0x00000046, 0x01, 0x02, 0x0000 },
     {  33, 0x0066, 0x00000046, 0x02, 0x00, 0x0000 },
     {  33, 0x0046, 0x00000046, 0x03, 0x00, 0x0000 },
     {  33, 0x0066, 0x04000046, 0x04, 0x00, 0x0000 },
@@ -334,8 +334,8 @@
     {  33, 0x0066, 0x0c000046, 0x0d, 0x00, 0x0000 },
     {  33, 0x0066, 0x0c000046, 0x0e, 0x00, 0x0000 },
     {  33, 0x0066, 0x0c000046, 0x0f, 0x00, 0x0000 },
-    {  34, 0x0067, 0x00000047, 0x00, 0x00, 0x0000 },
-    {  34, 0x0047, 0x00000047, 0x01, 0x00, 0x0000 },
+    {  34, 0x0067, 0x00000047, 0x00, 0x02, 0x0000 },
+    {  34, 0x0047, 0x00000047, 0x01, 0x02, 0x0000 },
     {  34, 0x0067, 0x00000047, 0x02, 0x00, 0x0000 },
     {  34, 0x0047, 0x00000047, 0x03, 0x00, 0x0000 },
     {  34, 0x0067, 0x04000047, 0x04, 0x00, 0x0000 },
@@ -350,8 +350,8 @@
     {  34, 0x0067, 0x0c000047, 0x0d, 0x00, 0x0000 },
     {  34, 0x0067, 0x0c000047, 0x0e, 0x00, 0x0000 },
     {  34, 0x0067, 0x0c000047, 0x0f, 0x00, 0x0000 },
-    {  35, 0x0068, 0x00000048, 0x00, 0x00, 0x0000 },
-    {  35, 0x0048, 0x00000048, 0x01, 0x00, 0x0000 },
+    {  35, 0x0068, 0x00000048, 0x00, 0x02, 0x0000 },
+    {  35, 0x0048, 0x00000048, 0x01, 0x02, 0x0000 },
     {  35, 0x0068, 0x00000048, 0x02, 0x00, 0x0000 },
     {  35, 0x0048, 0x00000048, 0x03, 0x00, 0x0000 },
     {  35, 0x0068, 0x04000048, 0x04, 0x00, 0x0000 },
@@ -366,8 +366,8 @@
     {  35, 0x0068, 0x0c000048, 0x0d, 0x00, 0x0000 },
     {  35, 0x0068, 0x0c000048, 0x0e, 0x00, 0x0000 },
     {  35, 0x0068, 0x0c000048, 0x0f, 0x00, 0x0000 },
-    {  36, 0x006a, 0x0000004a, 0x00, 0x00, 0x0000 },
-    {  36, 0x004a, 0x0000004a, 0x01, 0x00, 0x0000 },
+    {  36, 0x006a, 0x0000004a, 0x00, 0x02, 0x0000 },
+    {  36, 0x004a, 0x0000004a, 0x01, 0x02, 0x0000 },
     {  36, 0x006a, 0x0000004a, 0x02, 0x00, 0x0000 },
     {  36, 0x004a, 0x0000004a, 0x03, 0x00, 0x0000 },
     {  36, 0x006a, 0x0400004a, 0x04, 0x00, 0x0000 },
@@ -382,8 +382,8 @@
     {  36, 0x006a, 0x0c00004a, 0x0d, 0x00, 0x0000 },
     {  36, 0x006a, 0x0c00004a, 0x0e, 0x00, 0x0000 },
     {  36, 0x006a, 0x0c00004a, 0x0f, 0x00, 0x0000 },
-    {  37, 0x006b, 0x0000004b, 0x00, 0x00, 0x0000 },
-    {  37, 0x004b, 0x0000004b, 0x01, 0x00, 0x0000 },
+    {  37, 0x006b, 0x0000004b, 0x00, 0x02, 0x0000 },
+    {  37, 0x004b, 0x0000004b, 0x01, 0x02, 0x0000 },
     {  37, 0x006b, 0x0000004b, 0x02, 0x00, 0x0000 },
     {  37, 0x004b, 0x0000004b, 0x03, 0x00, 0x0000 },
     {  37, 0x006b, 0x0400004b, 0x04, 0x00, 0x0000 },
@@ -398,8 +398,8 @@
     {  37, 0x006b, 0x0c00004b, 0x0d, 0x00, 0x0000 },
     {  37, 0x006b, 0x0c00004b, 0x0e, 0x00, 0x0000 },
     {  37, 0x006b, 0x0c00004b, 0x0f, 0x00, 0x0000 },
-    {  38, 0x006c, 0x0000004c, 0x00, 0x00, 0x0000 },
-    {  38, 0x004c, 0x0000004c, 0x01, 0x00, 0x0000 },
+    {  38, 0x006c, 0x0000004c, 0x00, 0x02, 0x0000 },
+    {  38, 0x004c, 0x0000004c, 0x01, 0x02, 0x0000 },
     {  38, 0x006c, 0x0000004c, 0x02, 0x00, 0x0000 },
     {  38, 0x004c, 0x0000004c, 0x03, 0x00, 0x0000 },
     {  38, 0x006c, 0x0400004c, 0x04, 0x00, 0x0000 },
@@ -429,8 +429,8 @@
     {  43, 0x005c, 0x0000005c, 0x00, 0x00, 0x0000 },
     {  43, 0x007c, 0x0000007c, 0x01, 0x00, 0x0000 },
     {  43, 0x005c, 0x0400005c, 0x04, 0x00, 0x0000 },
-    {  44, 0x007a, 0x0000005a, 0x00, 0x00, 0x0000 },
-    {  44, 0x005a, 0x0000005a, 0x01, 0x00, 0x0000 },
+    {  44, 0x007a, 0x0000005a, 0x00, 0x02, 0x0000 },
+    {  44, 0x005a, 0x0000005a, 0x01, 0x02, 0x0000 },
     {  44, 0x007a, 0x0000005a, 0x02, 0x00, 0x0000 },
     {  44, 0x005a, 0x0000005a, 0x03, 0x00, 0x0000 },
     {  44, 0x007a, 0x0400005a, 0x04, 0x00, 0x0000 },
@@ -445,8 +445,8 @@
     {  44, 0x007a, 0x0c00005a, 0x0d, 0x00, 0x0000 },
     {  44, 0x007a, 0x0c00005a, 0x0e, 0x00, 0x0000 },
     {  44, 0x007a, 0x0c00005a, 0x0f, 0x00, 0x0000 },
-    {  45, 0x0078, 0x00000058, 0x00, 0x00, 0x0000 },
-    {  45, 0x0058, 0x00000058, 0x01, 0x00, 0x0000 },
+    {  45, 0x0078, 0x00000058, 0x00, 0x02, 0x0000 },
+    {  45, 0x0058, 0x00000058, 0x01, 0x02, 0x0000 },
     {  45, 0x0078, 0x00000058, 0x02, 0x00, 0x0000 },
     {  45, 0x0058, 0x00000058, 0x03, 0x00, 0x0000 },
     {  45, 0x0078, 0x04000058, 0x04, 0x00, 0x0000 },
@@ -461,8 +461,8 @@
     {  45, 0x0078, 0x0c000058, 0x0d, 0x00, 0x0000 },
     {  45, 0x0078, 0x0c000058, 0x0e, 0x00, 0x0000 },
     {  45, 0x0078, 0x0c000058, 0x0f, 0x00, 0x0000 },
-    {  46, 0x0063, 0x00000043, 0x00, 0x00, 0x0000 },
-    {  46, 0x0043, 0x00000043, 0x01, 0x00, 0x0000 },
+    {  46, 0x0063, 0x00000043, 0x00, 0x02, 0x0000 },
+    {  46, 0x0043, 0x00000043, 0x01, 0x02, 0x0000 },
     {  46, 0x0063, 0x00000043, 0x02, 0x00, 0x0000 },
     {  46, 0x0043, 0x00000043, 0x03, 0x00, 0x0000 },
     {  46, 0x0063, 0x04000043, 0x04, 0x00, 0x0000 },
@@ -477,8 +477,8 @@
     {  46, 0x0063, 0x0c000043, 0x0d, 0x00, 0x0000 },
     {  46, 0x0063, 0x0c000043, 0x0e, 0x00, 0x0000 },
     {  46, 0x0063, 0x0c000043, 0x0f, 0x00, 0x0000 },
-    {  47, 0x0076, 0x00000056, 0x00, 0x00, 0x0000 },
-    {  47, 0x0056, 0x00000056, 0x01, 0x00, 0x0000 },
+    {  47, 0x0076, 0x00000056, 0x00, 0x02, 0x0000 },
+    {  47, 0x0056, 0x00000056, 0x01, 0x02, 0x0000 },
     {  47, 0x0076, 0x00000056, 0x02, 0x00, 0x0000 },
     {  47, 0x0056, 0x00000056, 0x03, 0x00, 0x0000 },
     {  47, 0x0076, 0x04000056, 0x04, 0x00, 0x0000 },
@@ -493,8 +493,8 @@
     {  47, 0x0076, 0x0c000056, 0x0d, 0x00, 0x0000 },
     {  47, 0x0076, 0x0c000056, 0x0e, 0x00, 0x0000 },
     {  47, 0x0076, 0x0c000056, 0x0f, 0x00, 0x0000 },
-    {  48, 0x0062, 0x00000042, 0x00, 0x00, 0x0000 },
-    {  48, 0x0042, 0x00000042, 0x01, 0x00, 0x0000 },
+    {  48, 0x0062, 0x00000042, 0x00, 0x02, 0x0000 },
+    {  48, 0x0042, 0x00000042, 0x01, 0x02, 0x0000 },
     {  48, 0x0062, 0x00000042, 0x02, 0x00, 0x0000 },
     {  48, 0x0042, 0x00000042, 0x03, 0x00, 0x0000 },
     {  48, 0x0062, 0x04000042, 0x04, 0x00, 0x0000 },
@@ -509,8 +509,8 @@
     {  48, 0x0062, 0x0c000042, 0x0d, 0x00, 0x0000 },
     {  48, 0x0062, 0x0c000042, 0x0e, 0x00, 0x0000 },
     {  48, 0x0062, 0x0c000042, 0x0f, 0x00, 0x0000 },
-    {  49, 0x006e, 0x0000004e, 0x00, 0x00, 0x0000 },
-    {  49, 0x004e, 0x0000004e, 0x01, 0x00, 0x0000 },
+    {  49, 0x006e, 0x0000004e, 0x00, 0x02, 0x0000 },
+    {  49, 0x004e, 0x0000004e, 0x01, 0x02, 0x0000 },
     {  49, 0x006e, 0x0000004e, 0x02, 0x00, 0x0000 },
     {  49, 0x004e, 0x0000004e, 0x03, 0x00, 0x0000 },
     {  49, 0x006e, 0x0400004e, 0x04, 0x00, 0x0000 },
@@ -525,8 +525,8 @@
     {  49, 0x006e, 0x0c00004e, 0x0d, 0x00, 0x0000 },
     {  49, 0x006e, 0x0c00004e, 0x0e, 0x00, 0x0000 },
     {  49, 0x006e, 0x0c00004e, 0x0f, 0x00, 0x0000 },
-    {  50, 0x006d, 0x0000004d, 0x00, 0x00, 0x0000 },
-    {  50, 0x004d, 0x0000004d, 0x01, 0x00, 0x0000 },
+    {  50, 0x006d, 0x0000004d, 0x00, 0x02, 0x0000 },
+    {  50, 0x004d, 0x0000004d, 0x01, 0x02, 0x0000 },
     {  50, 0x006d, 0x0000004d, 0x02, 0x00, 0x0000 },
     {  50, 0x004d, 0x0000004d, 0x03, 0x00, 0x0000 },
     {  50, 0x006d, 0x0400004d, 0x04, 0x00, 0x0000 },